FilterGaussPyramidLayerUpBorder
Fixed Filters

Filters the image using a separable Gaussian filter kernel with user supplied floating point coefficients with upsampling and border control. More...

## Functions

NppStatus | nppiGetFilterGaussPyramidLayerUpBorderDstROI (int nSrcROIWidth, int nSrcROIHeight, NppiSize *pDstSizeROIMin, NppiSize *pDstSizeROIMax, Npp32f nRate)
| Calculate destination image minimum and maximum SizeROI width and height from source image ROI width and height and upsampling rate. More...
NppStatus | nppiFilterGaussPyramidLayerUpBorder_8u_C1R_Ctx (const Npp8u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp8u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType, NppStreamContext nppStreamCtx)
| Single channel 8-bit unsigned Gauss filter with upsampling and border control. More...
NppStatus | nppiFilterGaussPyramidLayerUpBorder_8u_C1R (const Npp8u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp8u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType)
NppStatus | nppiFilterGaussPyramidLayerUpBorder_8u_C3R_Ctx (const Npp8u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp8u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType, NppStreamContext nppStreamCtx)
| Three channel 8-bit unsigned Gauss filter with upsampling and border control. More...
NppStatus | nppiFilterGaussPyramidLayerUpBorder_8u_C3R (const Npp8u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp8u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType)
NppStatus | nppiFilterGaussPyramidLayerUpBorder_16u_C1R_Ctx (const Npp16u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp16u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType, NppStreamContext nppStreamCtx)
| Single channel 16-bit unsigned Gauss filter with upsampling and border control. More...
NppStatus | nppiFilterGaussPyramidLayerUpBorder_16u_C1R (const Npp16u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp16u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType)
NppStatus | nppiFilterGaussPyramidLayerUpBorder_16u_C3R_Ctx (const Npp16u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp16u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType, NppStreamContext nppStreamCtx)
| Three channel 16-bit unsigned Gauss filter with upsampling and border control. More...
NppStatus | nppiFilterGaussPyramidLayerUpBorder_16u_C3R (const Npp16u *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp16u *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType)
NppStatus | nppiFilterGaussPyramidLayerUpBorder_32f_C1R_Ctx (const Npp32f *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp32f *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType, NppStreamContext nppStreamCtx)
| Single channel 32-bit floating-point Gauss filter upsampling and with border control. More...
NppStatus | nppiFilterGaussPyramidLayerUpBorder_32f_C1R (const Npp32f *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp32f *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType)
NppStatus | nppiFilterGaussPyramidLayerUpBorder_32f_C3R_Ctx (const Npp32f *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp32f *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType, NppStreamContext nppStreamCtx)
| Three channel 32-bit floating-point Gauss filter with upsampling and border control. More...
NppStatus | nppiFilterGaussPyramidLayerUpBorder_32f_C3R (const Npp32f *pSrc, Npp32s nSrcStep, NppiSize oSrcSize, NppiPoint oSrcOffset, Npp32f *pDst, Npp32s nDstStep, NppiSize oSizeROI, Npp32f nRate, const int nFilterTaps, const Npp32f *pKernel, NppiBorderType eBorderType)

## Detailed Description

Filters the image using a separable Gaussian filter kernel with user supplied floating point coefficients with upsampling and border control.

If the upsampling rate is equivalent to an integer value then unnecessary source pixels are just skipped. If any portion of the mask overlaps the source image boundary the requested border type operation is applied to all mask pixels which fall outside of the source image.

Currently only the NPP_BORDER_MIRROR and NPP_BORDER_REPLICATE border type operations are supported.

### Common parameters for nppiFilterGaussPyramidLayerUpBorder functions include:

Parameters

  pSrc | Source-Image Pointer.
  nSrcStep | Source-Image Line Step.
  oSrcSize | Source image width and height in pixels relative to pSrc.
  oSrcOffset | The pixel offset that pSrc points to relative to the origin of the source image.
  pDst | Destination-Image Pointer.
  nDstStep | Destination-Image Line Step.
  oSizeROI | Region-of-Interest (ROI).
  nRate | The upsampling rate to be used. For integer equivalent rates unnecessary source pixels are just skipped. For non-integer rates the source image is bilinear interpolated. nRate must be > 1.0F and <= 10.0F.
  nFilterTaps | The number of filter taps where nFilterTaps = 2 * ((int)((float)ceil(radius) + 0.5F) ) + 1.
  pKernel | Pointer to an array of nFilterTaps kernel coefficients which sum to 1.0F.
  eBorderType | The border type operation to be applied at source image border boundaries.
  nppStreamCtx | Application Managed Stream Context.

Returns
  Image Data Related Error Codes, ROI Related Error Codes

## Function Documentation

NppStatus nppiFilterGaussPyramidLayerUpBorder_16u_C1R | ( | const Npp16u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp16u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType
| ) |  |

NppStatus nppiFilterGaussPyramidLayerUpBorder_16u_C1R_Ctx | ( | const Npp16u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp16u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType,
|  | NppStreamContext | nppStreamCtx
| ) |  |

Single channel 16-bit unsigned Gauss filter with upsampling and border control.

For common parameter descriptions, see Common parameters for nppiFilterGaussPyramidLayerUpBorder functions.

NppStatus nppiFilterGaussPyramidLayerUpBorder_16u_C3R | ( | const Npp16u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp16u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType
| ) |  |

NppStatus nppiFilterGaussPyramidLayerUpBorder_16u_C3R_Ctx | ( | const Npp16u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp16u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType,
|  | NppStreamContext | nppStreamCtx
| ) |  |

Three channel 16-bit unsigned Gauss filter with upsampling and border control.

For common parameter descriptions, see Common parameters for nppiFilterGaussPyramidLayerUpBorder functions.

NppStatus nppiFilterGaussPyramidLayerUpBorder_32f_C1R | ( | const Npp32f * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp32f * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType
| ) |  |

NppStatus nppiFilterGaussPyramidLayerUpBorder_32f_C1R_Ctx | ( | const Npp32f * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp32f * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType,
|  | NppStreamContext | nppStreamCtx
| ) |  |

Single channel 32-bit floating-point Gauss filter upsampling and with border control.

For common parameter descriptions, see Common parameters for nppiFilterGaussPyramidLayerUpBorder functions.

NppStatus nppiFilterGaussPyramidLayerUpBorder_32f_C3R | ( | const Npp32f * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp32f * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType
| ) |  |

NppStatus nppiFilterGaussPyramidLayerUpBorder_32f_C3R_Ctx | ( | const Npp32f * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp32f * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType,
|  | NppStreamContext | nppStreamCtx
| ) |  |

Three channel 32-bit floating-point Gauss filter with upsampling and border control.

For common parameter descriptions, see Common parameters for nppiFilterGaussPyramidLayerUpBorder functions.

NppStatus nppiFilterGaussPyramidLayerUpBorder_8u_C1R | ( | const Npp8u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp8u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType
| ) |  |

NppStatus nppiFilterGaussPyramidLayerUpBorder_8u_C1R_Ctx | ( | const Npp8u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp8u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType,
|  | NppStreamContext | nppStreamCtx
| ) |  |

Single channel 8-bit unsigned Gauss filter with upsampling and border control.

For common parameter descriptions, see Common parameters for nppiFilterGaussPyramidLayerUpBorder functions.

NppStatus nppiFilterGaussPyramidLayerUpBorder_8u_C3R | ( | const Npp8u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp8u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType
| ) |  |

NppStatus nppiFilterGaussPyramidLayerUpBorder_8u_C3R_Ctx | ( | const Npp8u * | pSrc,
|  | Npp32s | nSrcStep,
|  | NppiSize | oSrcSize,
|  | NppiPoint | oSrcOffset,
|  | Npp8u * | pDst,
|  | Npp32s | nDstStep,
|  | NppiSize | oSizeROI,
|  | Npp32f | nRate,
|  | const int | nFilterTaps,
|  | const Npp32f * | pKernel,
|  | NppiBorderType | eBorderType,
|  | NppStreamContext | nppStreamCtx
| ) |  |

Three channel 8-bit unsigned Gauss filter with upsampling and border control.

For common parameter descriptions, see Common parameters for nppiFilterGaussPyramidLayerUpBorder functions.

NppStatus nppiGetFilterGaussPyramidLayerUpBorderDstROI | ( | int | nSrcROIWidth,
|  | int | nSrcROIHeight,
|  | NppiSize * | pDstSizeROIMin,
|  | NppiSize * | pDstSizeROIMax,
|  | Npp32f | nRate
| ) |  |

Calculate destination image minimum and maximum SizeROI width and height from source image ROI width and height and upsampling rate.

It is highly recommended that this function be use to determine the best destination image ROI for consistent results.

Parameters

  nSrcROIWidth | The desired source image ROI width, must be <= oSrcSize.width.
  nSrcROIHeight | The desired source image ROI height, must be <= oSrcSize.height.
  pDstSizeROIMin | Host memory pointer to the minimum recommended destination image roi_specification.
  pDstSizeROIMax | Host memory pointer to the maximum recommended destination image roi_specification.
  nRate | The upsampling rate to be used. For integer equivalent rates unnecessary source pixels are just skipped. For non-integer rates the source image is bilinear interpolated. nRate must be > 1.0F and <= 10.0F.

Returns
  Image Data Related Error Codes, ROI Related Error Codes

Copyright © 2009-2018 NVIDIA Corporation